﻿#define NORMAL
#undef NORMAL
#define SMARTSPLASH
#undef SMARTSPLASH
#define FORMEVENT
// #undef FORMEVENT

using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace TechNote66_Loading_CS
{
    public partial class Form1 : Form
    {
        // 폼 생성자 - 가장 먼저 실행되는 함수
        public Form1()
        {
#if (SMARTSPLASH)
            // [CASE-2] Form_Load()시 ChildForm 일괄 생성하는 방식 + SmartSplash
            SmartX.SmartSplash.Start("Flash Disk\\Loading.gif", 100);
#endif
            InitializeComponent();
        }

        private Form2 frm2;
        private Form3 frm3;
        private Form4 frm4;
        private Form5 frm5;
        private Form6 frm6;
        private Form7 frm7;
        private Form8 frm8;
        private Form9 frm9;
        private Form10 frm10;

        public SmartX.SmartButton Form1AirconButton
        {
            get
            {
                return btnAircon;
            }
        }

        public SmartX.SmartButton Form2EngineButton
        {
            get
            {
                return frm2.EngineButton;
            }
        }

        public SmartX.SmartButton Form3SensorButton
        {
            get
            {
                return frm3.SensorButton;
            }
        }

        public SmartX.SmartButton Form4SettingButton
        {
            get
            {
                return frm4.SettingButton;
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
#if (NORMAL)
            // [CASE-1] Form_Load 시 ChildForm 일괄 생성하는 방식의 시작
            frm2 = new Form2();
            frm3 = new Form3();
            frm4 = new Form4();
            frm5 = new Form5();
            frm6 = new Form6();
            frm7 = new Form7();
            frm8 = new Form8();
            frm9 = new Form9();
            frm10 = new Form10();

            smartForm1.MainForm = this;
            smartForm1.Show(0);

            smartForm1.AddChildForm(frm2);
            smartForm1.AddChildForm(frm3);
            smartForm1.AddChildForm(frm4);
            smartForm1.AddChildForm(frm5);
            smartForm1.AddChildForm(frm6);
            smartForm1.AddChildForm(frm7);
            smartForm1.AddChildForm(frm8);
            smartForm1.AddChildForm(frm9);
            smartForm1.AddChildForm(frm10);
            // [CASE-1] 끝
#endif

#if (SMARTSPLASH)
            frm2 = new Form2();
            frm3 = new Form3();
            frm4 = new Form4();
            frm5 = new Form5();
            frm6 = new Form6();
            frm7 = new Form7();
            frm8 = new Form8();
            frm9 = new Form9();
            frm10 = new Form10();

            smartForm1.MainForm = this;
            smartForm1.Show(0);

            smartForm1.AddChildForm(frm2);
            smartForm1.AddChildForm(frm3);
            smartForm1.AddChildForm(frm4);
            smartForm1.AddChildForm(frm5);
            smartForm1.AddChildForm(frm6);
            smartForm1.AddChildForm(frm7);
            smartForm1.AddChildForm(frm8);
            smartForm1.AddChildForm(frm9);
            smartForm1.AddChildForm(frm10);

            SmartX.SmartSplash.Finish();
            // [CASE-2] 끝
#endif

#if (FORMEVENT)
            smartForm1.MainForm = this;
            smartForm1.Show(0);
#endif

            btnAircon.ButtonDown();
        }

        private void smartForm1_OnFormLoadCompleting()
        {
#if (FORMEVENT)
            // [CASE-3] MainForm Load 이후 ChildForm을 따로 생성하는 방식
            SmartX.SmartSplash.Start("Flash Disk\\Loading.gif", 100);

            smartForm1.Enabled = false;

            frm2 = new Form2();
            frm3 = new Form3();
            frm4 = new Form4();
            frm5 = new Form5();
            frm6 = new Form6();
            frm7 = new Form7();
            frm8 = new Form8();
            frm9 = new Form9();
            frm10 = new Form10();

            smartForm1.AddChildForm(frm2);
            smartForm1.AddChildForm(frm3);
            smartForm1.AddChildForm(frm4);
            smartForm1.AddChildForm(frm5);
            smartForm1.AddChildForm(frm6);
            smartForm1.AddChildForm(frm7);
            smartForm1.AddChildForm(frm8);
            smartForm1.AddChildForm(frm9);
            smartForm1.AddChildForm(frm10);
#endif
        }

        private void smartForm1_OnFormLoadCompleted()
        {
#if (FORMEVENT)
            // [CASE-3] 끝
            smartForm1.Enabled = true;
            SmartX.SmartSplash.Finish();
#endif
        }

        private void btnAircon_Click(object sender, EventArgs e)
        {
            smartForm1.Show(0);
            btnAircon.ButtonDown();
        }

        private void btnEngine_Click(object sender, EventArgs e)
        {
            smartForm1.Show(1);
            frm2.EngineButton.ButtonDown();
        }

        private void btnSensor_Click(object sender, EventArgs e)
        {
            smartForm1.Show(2);
            frm3.SensorButton.ButtonDown();
        }

        private void btnSetting_Click(object sender, EventArgs e)
        {
            smartForm1.Show(3);
            frm4.SettingButton.ButtonDown();
        }
    }
}